package eu.jonahbauer.wizard.common.messages.observer;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonParseException;
import eu.jonahbauer.wizard.common.util.SealedClassTypeAdapterFactory;
import lombok.EqualsAndHashCode;

@EqualsAndHashCode
public abstract sealed class ObserverMessage permits CardMessage, HandMessage, PredictionMessage, ScoreMessage, StateMessage, TrickMessage, TrumpMessage, UserInputMessage {
    private static final Gson GSON = new GsonBuilder()
            .registerTypeAdapterFactory(SealedClassTypeAdapterFactory.of(ObserverMessage.class, "Message"))
            .create();

    public static ObserverMessage parse(String json) throws JsonParseException {
        return GSON.fromJson(json, ObserverMessage.class);
    }

    @Override
    public String toString() {
        return GSON.toJson(this, ObserverMessage.class);
    }
}